//DJS 5_6_16

`timescale 1ps/1ps
module deserializer
(
	rx_reset,
	clk,
	sdo,
   parallel_data,
	num_bits
);

input rx_reset,clk,sdo,num_bits;
output parallel_data;

reg [15:0] parallel_data;
wire rx_reset;
integer bit_index,msb_bit_index;
wire [5:0] num_bits;

always @ (clk)  //decode the number of bits
begin
case(num_bits)
	5'd16:
		msb_bit_index = 15;
	5'd14:
		msb_bit_index = 15;
	5'd12:
		msb_bit_index = 13;
	default:
		msb_bit_index = 15;
endcase
end

always @(posedge clk or posedge rx_reset)
begin	
		if(rx_reset)	
			bit_index = msb_bit_index;
		else
		begin   	
			parallel_data[bit_index] = sdo;
			if(bit_index >= 1)
      		bit_index = bit_index - 1;	
		end   
end 

endmodule